/*
 * Copyright (C) 2000  Florian Sander
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

char seen_reply[1024];
static char *do_seen(char *mask, char *nick, char *uhost, char *chan, int bns)
{
  char hostbuf[UHOSTLEN + 1], newhostbuf[UHOSTLEN + 1], *host, *newhost;
  seendat *l;
  gseenres *r;
  int wild, nr;
  char s[512], *dur, bnquery[256];
  struct userrec *u;
  struct laston_info *li;

  Context;
  l = NULL;
  seen_reply[0] = 0;
  host = hostbuf;
  newhost = newhostbuf;
  mask = newsplit(&mask);
  while (mask[0] == ' ')
    mask++;
  if (!mask[0]) {
    sprintf(seen_reply, "do you know what a parameter is?");
    return seen_reply;
  }
  if (strchr(mask, '?') || strchr(mask, '*'))
    wild = 1;
  else {
    if (!strcasecmp(mask, nick)) {
      sprintf(seen_reply, "do I look like a mirror? ^_^");
      return seen_reply;
    }
    if (onchan(mask, chan)) {
      sprintf(seen_reply, "if you can't see %s here right now, you probably need new glasses. ^_^", mask);
      return seen_reply;
    }
    add_seenreq(mask, nick, uhost, chan, now);
    wild = 0;
    l = findseen(mask);
    if (!l) {
      u = get_user_by_handle(userlist, mask);
      if (u) {
        li = get_user(&USERENTRY_LASTON, u);
      }
      if (!u || !li) {
        if ((strlen(mask) + 30) < 1024)
          sprintf(seen_reply, "I don't remember seeing %s", mask);
        else
          sprintf(seen_reply, "no matches to your query");
        if (bns && ((strlen(mask) + strlen(nick) + strlen(uhost)
            + strlen(chan) + 20) < 255)) {
          debug0("trying botnet seen");
          if (bnsnick)
            nfree(bnsnick);
          if (bnschan)
            nfree(bnschan);
          bnsnick = nmalloc(strlen(nick) + 1);
          strcpy(bnsnick, nick);
          bnschan = nmalloc(strlen(chan) + 1);
          strcpy(bnschan, chan);
          sprintf(bnquery, "gseen_req %s %s %s %s", mask, nick, uhost, chan);
          botnet_send_zapf_broad(-1, botnetnick, NULL, bnquery);
        }
      } else {
        dur = duration(now - li->laston);
        if ((strlen(mask) + strlen(dur) + 25) < 1024)
          sprintf(seen_reply, "I haven't seen %s for %s.", mask, dur);
      }
      return seen_reply;
    }
    if (strlen(l->host) < UHOSTLEN)
      maskhost(l->host, host);
    else {
      sprintf(seen_reply, "error, too long host");
      return seen_reply;
    }
  }
  if (l && (l->type == SEEN_CHPT)) {
    sprintf(seen_reply, do_seennick(l));
    return seen_reply;
  }
  for (l = seendata; l; l = l->next) {
    if ((strlen(l->host) + strlen(l->nick) + 2) > UHOSTLEN)
      continue;
    if (!l->host[0])
      continue;
    sprintf(newhost, "%s!%s", l->nick, (!strict_host && strchr("~+-^=", l->host[0])) ? (l->host + 1) : l->host);
    if (!wild) {
      if (wild_match(host, newhost))
       add_seenresult(l);
    } else {
      if (wild_match(mask, l->nick) || wild_match(mask, newhost))
	add_seenresult(l);
    }
  }
  if (!results) {
    sprintf(seen_reply, "I found no matches to your query.");
    return seen_reply;
  }
  sortresults();
  if (strcasecmp(results->seen->nick, mask)) {
    nr = count_seenresults();
    sprintf(seen_reply, "I found %d match%s to your query%s", nr,
            (nr == 1) ? "" : "es",
    	    (nr > 5) ? ". This are the 5 most recent ones:" : ":");
    nr = 0;
    for (r = results; (r && (nr < 5)); r = r->next) {
      nr++;
      if ((strlen(seen_reply) + 1 + strlen(r->seen->nick)) < 1024)
        sprintf(seen_reply, "%s%s %s", seen_reply, (nr > 1) ? "," : "", r->seen->nick);
    }
    sprintf(s, do_seennick(results->seen));
    if ((strlen(seen_reply) + 2 + strlen(s)) < 1024)
      sprintf(seen_reply, "%s. %s", seen_reply, s);
  } else
    sprintf(seen_reply, do_seennick(results->seen));
  free_seenresults();
  return seen_reply;
}

char seennick_reply[512];
static char *do_seennick(seendat *l)
{
  char *dur, ts[20], buf[256], *k, *msg;
  time_t tt;

  Context;
  seennick_reply[0] = 0;
  if (!l) {
    debug0("ERROR! Tryed to do a seennick on a NULL pointer!");
    sprintf(seennick_reply, "ERROR!");
    return seennick_reply;
  }
  sprintf(seennick_reply, "%s (%s) was last seen", l->nick, l->host);
  dur = duration(now - l->when);
  tt = l->when;
  strftime(ts, 19, "%d.%m. %H:%M", localtime(&tt));
  switch (l->type) {
    case SEEN_JOIN:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
      	  + 20) < 512) {
        sprintf(seennick_reply, "%s joining %s %s ago (%s)", seennick_reply,
		l->chan, dur, ts);
	if (onchan(l->nick, l->chan)) {
	  if ((strlen(seennick_reply) + strlen(l->nick) + 20) < 512)
	    sprintf(seennick_reply, "%s. %s is still there.", seennick_reply,
            l->nick);
	} else if (strcmp(l->chan, "[secret]")) {
	  if ((strlen(seennick_reply) + strlen(l->nick) + strlen(l->chan) + 30)
	      < 512)
	    sprintf(seennick_reply, "%s. I can't see %s on %s, though.",
	    	    seennick_reply, l->nick, l->chan);
        }
      }
      break;
    case SEEN_PART:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) +
          strlen(ts) + strlen(l->msg) + 30) < 512) {
        sprintf(seennick_reply, "%s parting %s %s ago (%s)%s%s%s",
		seennick_reply,	l->chan, dur, ts, l->msg[0] ?" stating \"" :
                ".", l->msg[0] ? l->msg : "", l->msg[0] ? "\"" : "");
	if (l->spent > -1) {
          dur = duration(l->spent);
	  if ((strlen(seennick_reply) + strlen(dur) + 30) < 512)
	    sprintf(seennick_reply, "%s after spending %s there.",
	    	    seennick_reply, dur);
	} else
	  sprintf(seennick_reply, "%s.", seennick_reply);
      }
      break;
    case SEEN_SIGN:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) +
          strlen(ts) + strlen(l->msg) + 40) < 512) {
        sprintf(seennick_reply, "%s quitting from %s %s ago (%s)%s%s%s",
		seennick_reply,	l->chan, dur, ts, l->msg[0] ? " stating \"" :
                ".", l->msg[0] ? l->msg : "", l->msg[0] ? "\"" : "");
	if (l->spent > -1) {
          dur = duration(l->spent);
	  if ((strlen(seennick_reply) + strlen(dur) + 30) < 512)
	    sprintf(seennick_reply, "%s after spending %s there.",
	    	    seennick_reply, dur);
	} else
	  sprintf(seennick_reply, "%s.", seennick_reply);
      }
      break;
    case SEEN_NICK:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
      	  + 45 + strlen(l->msg)) < 512) {
        sprintf(seennick_reply, "%s changing his/her nick to %s on %s %s ago (%s)",
                seennick_reply, l->msg, l->chan, dur, ts);
	if (onchan(l->msg, l->chan)) {
	  if ((strlen(seennick_reply) + strlen(l->msg) + 20) < 512)
	    sprintf(seennick_reply, "%s. %s is still there.", seennick_reply,
                    l->msg);
	} else if (strcmp(l->chan, "[secret]")) {
	  if ((strlen(seennick_reply) + strlen(l->msg) + strlen(l->chan) + 30)
	      < 512)
	    sprintf(seennick_reply, "%s. I can't see %s on %s, though.",
	    	    seennick_reply, l->msg, l->chan);
        }
      }
      break;
    case SEEN_NCKF:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
      	  + 45 + strlen(l->msg)) < 512) {
        sprintf(seennick_reply, "%s changing his/her nick from %s on %s %s ago (%s)",
                seennick_reply, l->msg, l->chan, dur, ts);
	if (onchan(l->nick, l->chan)) {
	  if ((strlen(seennick_reply) + strlen(l->nick) + 20) < 512)
	    sprintf(seennick_reply, "%s. %s is still there.", seennick_reply,
            l->nick);
	} else if (strcmp(l->chan, "[secret]")) {
	  if ((strlen(seennick_reply) + strlen(l->nick) + strlen(l->chan) + 30)
	      < 512)
	    sprintf(seennick_reply, "%s. I can't see %s on %s, though.",
	    	    seennick_reply, l->nick, l->chan);
        }
      }
      break;
    case SEEN_KICK:
      msg = buf;
      strncpy(buf, l->msg, 255);
      msg[255] = 0;
      k = newsplit(&msg);
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(k) + strlen(msg)
          + strlen(dur) + strlen(ts) + 50) < 512)
        sprintf(seennick_reply, "%s being kicked from %s by %s (%s) %s ago (%s).",
		seennick_reply, l->chan, k, msg, dur, ts);
      if (l->spent > -1) {
        dur = duration(l->spent);
        if ((strlen(seennick_reply) + strlen(dur) + 30) < 512)
          sprintf(seennick_reply, "%s after spending %s there.",
                  seennick_reply, dur);
      } else
        sprintf(seennick_reply, "%s.", seennick_reply);
      break;
    case SEEN_SPLT:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
          + 33) < 512)
        sprintf(seennick_reply, "%s splitting from %s %s ago (%s).",
                seennick_reply, l->chan, dur, ts);
      break;
    case SEEN_REJN:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
          + 45) < 512)
        sprintf(seennick_reply, "%s rejoining %s from a netsplit %s ago (%s).",
                seennick_reply, l->chan, dur, ts);
      break;
    case SEEN_CHJN:
      if (strcmp(l->chan, "0")) {
        if ((strlen(seennick_reply) + strlen(l->chan)
            + strlen(l->msg) + strlen(dur) + strlen(ts) + 55) < 512) {
          sprintf(seennick_reply, "%s joining the botnet channel %s from %s %s ago (%s).",
                  seennick_reply, l->chan, l->msg, dur, ts);
        }
      } else if ((strlen(seennick_reply) + strlen(l->chan) + strlen(l->msg)
                 + strlen(dur) + strlen(ts) + 55) < 512)
        sprintf(seennick_reply, "%s joining the party line from %s %s ago (%s).",
                seennick_reply, l->msg, dur, ts);
      break;
    case SEEN_CHPT:
      if (strcmp(l->chan, "0")) {
        if ((strlen(seennick_reply) + strlen(l->chan)
            + strlen(l->msg) + strlen(dur) + strlen(ts) + 55) < 512) {
          sprintf(seennick_reply, "%s leaving the botnet channel %s from %s %s ago (%s).",
                  seennick_reply, l->chan, l->msg, dur, ts);
        }
      } else if ((strlen(seennick_reply) + strlen(l->chan) + strlen(l->msg)
                 + strlen(dur) + strlen(ts) + 55) < 512)
        sprintf(seennick_reply, "%s leaving the partyline from %s %s ago (%s).",
                seennick_reply, l->msg, dur, ts);
      break;
    default:
      if ((strlen(seennick_reply) + strlen(l->chan) + strlen(dur) + strlen(ts)
      	  + 15) < 512)
        sprintf(seennick_reply, "%s on %s %s ago (%s).", seennick_reply,
		l->chan, dur, ts);
      else
        sprintf(seennick_reply, "ERROR, result too long.");
  }
  return seennick_reply;
}

char seenstats_reply[512];
static char *do_seenstats()
{
  sprintf(seenstats_reply, "I'm currently tracking %d nicks using %d bytes.",
  	  count_seens(), gseen_expmem());
  return seenstats_reply;
}

static void add_seenresult(seendat *seen)
{
  gseenres *l, *nl;

  l = results;
  while (l && l->next)
    l = l->next;
  nl = nmalloc(sizeof(gseenres));
  nl->seen = seen;
  nl->next = NULL;
  if (!results)
    results = nl;
  else
    l->next = nl;
}

static int expmem_seenresults()
{
  int bytes = 0;
  gseenres *l;

  for (l = results; l; l = l->next)
    bytes += sizeof(gseenres);
  return bytes;
}

static int count_seenresults()
{
  int nr;
  gseenres *l;

  nr = 0;
  for (l = results; l; l = l->next)
    nr++;
  return nr;
}

static void free_seenresults()
{
  gseenres *l, *ll;

  l = results;
  while (l) {
    ll = l->next;
    nfree(l);
    l = ll;
  }
  results = NULL;
}

static void sortresults()
{
  int again = 1;
  gseenres *last, *p, *c, *n;
  int a, b;

  Context;
  again = 1;
  last = NULL;
  while ((results != last) && (again)) {
    p = NULL;
    c = results;
    n = c->next;
    again = 0;
    while (n != last) {
      if (!c || !n)
        a = b = 0;
      else
        a = c->seen->when;
        b = n->seen->when;
      if (a < b) {
  again = 1;
  c->next = n->next;
  n->next = c;
  if (p == NULL)
    results = n;
  else
    p->next = n;
      }
      p = c;
      c = n;
      n = n->next;
    }
    last = c;
  }
  Context;
  return;
}

static void sortrequests(seenreq *l)
{
  int again = 1;
  seenreq_by *last, *p, *c, *n;
  int a, b;

  Context;
  again = 1;
  last = NULL;
  while ((l->by != last) && (again)) {
    p = NULL;
    c = l->by;
    n = c->next;
    again = 0;
    while (n != last) {
      if (!c || !n)
        a = b = 0;
      else
        a = c->when;
        b = n->when;
      if (a < b) {
  again = 1;
  c->next = n->next;
  n->next = c;
  if (p == NULL)
    l->by = n;
  else
    p->next = n;
      }
      p = c;
      c = n;
      n = n->next;
    }
    last = c;
  }
  Context;
  return;
}

/* stolen from tcl_duration in tclmisc.c */
char duration_temp[256];
static char *duration(int seconds)
{
  char s[256];
  time_t sec;

  Context;
  sec = seconds;
  s[0] = 0;

  if (sec < 1) {
    sprintf(duration_temp, "0 seconds");
    return duration_temp;
  }
  if (sec >= 31536000) {
    sprintf(s, "%d year", (int) (sec / 31536000));
    if ((int) (sec / 31536000) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 31536000)) * 31536000);
  }
  if (sec >= 604800) {
    sprintf(&s[strlen(s)], "%d week", (int) (sec / 604800));
    if ((int) (sec / 604800) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 604800)) * 604800);
  }
  if (sec >= 86400) {
    sprintf(&s[strlen(s)], "%d day", (int) (sec / 86400));
    if ((int) (sec / 86400) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 86400)) * 86400);
  }
  if (sec >= 3600) {
    sprintf(&s[strlen(s)], "%d hour", (int) (sec / 3600));
    if ((int) (sec / 3600) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 3600)) * 3600);
  }
  if (sec >= 60) {
    sprintf(&s[strlen(s)], "%d minute", (int) (sec / 60));
    if ((int) (sec / 60) > 1)
      strcat(s, "s");
    strcat(s, " ");
    sec -= (((int) (sec / 60)) * 60);
  }
  if (sec > 0) {
    sprintf(&s[strlen(s)], "%d second", (int) (sec / 1));
    if ((int) (sec / 1) > 1)
      strcat(s, "s");
  }
  sprintf(duration_temp, "%s", s);
  Context;
  return duration_temp;
}

static int onchan(char *nick, char *chan)
{
  struct chanset_t *ch;
  memberlist *m;

  ch = findchan_by_dname(chan);
  if (!ch)
    return 0;
  m = ismember(ch, nick);
  if (!m)
    return 0;
  else if (chan_issplit(m))
    return 0;
  else
    return 1;
}

static int count_seens()
{
  int nr;
  seendat *l;

  nr = 0;
  for (l = seendata; l; l = l->next)
    nr++;
  return nr;
}

static void add_seenreq(char *nick, char *from, char *host, char *chan,
			time_t when)
{
  seenreq *l, *nl;
  seenreq_by *b, *nb;
  char buf[10] = "[secret]";

  Context;
  if (!tell_seens)
    return;
  if (strcmp(chan, "[partyline]") && secretchan(chan))
    chan = buf;
  for (l = requests; l; l = l->next) {
    if (!strcasecmp(nick, l->nick)) {
      for (b = l->by; b; b = b->next) {
	if (!strcasecmp(from, b->who)) {
	  nfree(b->chan);
	  b->chan = nmalloc(strlen(chan) + 1);
	  strcpy(b->chan, chan);
	  b->when = when;
	  return;
	}
      }
      b = l->by;
      while (b && b->next)
        b = b->next;
      nb = nmalloc(sizeof(seenreq_by));
      nb->who = nmalloc(strlen(from) + 1);
      strcpy(nb->who, from);
      nb->host = nmalloc(strlen(host) + 1);
      strcpy(nb->host, host);
      nb->chan = nmalloc(strlen(chan) + 1);
      strcpy(nb->chan, chan);
      nb->when = when;
      nb->next = NULL;
      if (l->by)
        b->next = nb;
      else
        l->by = nb;
      return;
    }
  }
  nb = nmalloc(sizeof(seenreq_by));
  nb->who = nmalloc(strlen(from) + 1);
  strcpy(nb->who, from);
  nb->host = nmalloc(strlen(host) + 1);
  strcpy(nb->host, host);
  nb->chan = nmalloc(strlen(chan) + 1);
  strcpy(nb->chan, chan);
  nb->when = when;
  nb->next = NULL;
  l = requests;
  while (l && l->next)
    l = l->next;
  nl = nmalloc(sizeof(seenreq));
  nl->nick = nmalloc(strlen(nick) + 1);
  strcpy(nl->nick, nick);
  nl->by = nb;
  nl->next = NULL;
  if (requests)
    l->next = nl;
  else
    requests = nl;
}

static int expmem_seenreq()
{
  seenreq *l;
  seenreq_by *b;
  int size;

  size = 0;
  for (l = requests; l; l = l->next) {
    size += sizeof(seenreq);
    size += strlen(l->nick) + 1;
    for (b = l->by; b; b = b->next) {
      size += sizeof(seenreq_by);
      size += strlen(b->who) + 1;
      size += strlen(b->host) + 1;
      size += strlen(b->chan) + 1;
    }
  }
  return size;
}

static int count_seenreq(seenreq_by *b)
{
  seenreq_by *l;
  int nr;

  nr = 0;
  for (l = b; l; l = l->next)
    nr++;
  return nr;
}

static void free_seenreq()
{
  seenreq *l, *ll;
  seenreq_by *b, *bb;

  Context;
  l = requests;
  while (l) {
    b = l->by;
    while (b) {
      bb = b->next;
      nfree(b->who);
      nfree(b->host);
      nfree(b->chan);
      nfree(b);
      b = bb;
    }
    ll = l->next;
    nfree(l->nick);
    nfree(l);
    l = ll;
  }
  requests = NULL;
}

static void report_seenreq(char *nick)
{
  seenreq *l, *ll;
  seenreq_by *b, *bb;
  char reply[512], ts[20], *dur;
  int nr;
  time_t tt;

  if (!tell_seens)
    return;
  ll = NULL;
  l = requests;
  while (l) {
    if (!strcasecmp(l->nick, nick)) {
      nr = count_seenreq(l->by);
      if (nr == 1) {
        dur = duration(now - l->by->when);
        tt = l->by->when;
        strftime(ts, 19, "%d.%m. %H:%M", localtime(&tt));
        dprintf(DP_HELP, "NOTICE %s :%s was looking for you on %s %s ago (%s).\n",
		l->nick, l->by->who, l->by->chan, dur, ts);
      } else {
        sortrequests(l);
        dur = duration(now - l->by->when);
        tt = l->by->when;
        strftime(ts, 19, "%d.%m. %H:%M", localtime(&tt));
	sprintf(reply, "There have been %d users looking for you:", nr);
	nr = 0;
	for (b = l->by; b; b = b->next) {
	  nr++;
	  if ((strlen(reply) + strlen(b->who) + 2) < 512) {
	    sprintf(reply, "%s%s%s", reply, (nr == 1) ? " " : ", ", b->who);
	  }
	}
	if ((strlen(reply) + strlen(l->by->who) + strlen(l->by->host)
	    + strlen(l->by->chan) + strlen(dur) + strlen(ts) + 50) < 512)
	  sprintf(reply, "%s. The last one was %s (%s) on %s %s ago (%s).",
	  	  reply, l->by->who, l->by->host, l->by->chan, dur, ts);
	dprintf(DP_HELP, "NOTICE %s :%s\n", l->nick, reply);
      }
      b = l->by;
      while (b) {
	bb = b->next;
	nfree(b->who);
	nfree(b->host);
	nfree(b->chan);
	nfree(b);
	b = bb;
      }
      nfree(l->nick);
      if (ll)
        ll->next = l->next;
      else
        requests = l->next;
      nfree(l);
      if (ll)
        l = ll->next;
      else
        l = requests;
    } else {
      ll = l;
      l = l->next;
    }
  }
}
